<?php

require_once 'phpargs.php';

$kurssit = array();
$maat    = array();

$kurssit['EUR'] = 1;

$cachefile = 'volatile/valukon/sav';
if(@filemtime($cachefile) < time()-3600*6)
  exec('./ttvparser - + 17302 > '.$cachefile);

###############
## Parempi lhde:
# http://www.suomenpankki.fi/ohi/fin/0_new/0.1_valuuttak/fix-rec.txt
#
# Formaatti:
# 5.6.2003 JPY/EUR 139.28
# 5.6.2003 GBP/EUR 0.71210
# jne
#
# Tai taulukkona:
# http://www.suomenpankki.fi/ohi/fin/0_new/0.1_valuuttak/fix-fin-bw.htm
# tst nkee maatkin ja valuuttojen nimet.


$lines = file($cachefile);

foreach($lines as $line)
  if(ereg('[[:upper:]]{3}.*[0-9]', $line))
  {
    $maa    = trim(ereg_replace(' [[:upper:]]{3} *[0-9].*', '', $line));
    $koodi  = trim(ereg_replace('.* ([[:upper:]]{3}).*', '\1', $line));
    $kurssi = trim(ereg_replace('.* [[:upper:]]{3} *', '', $line));
    
    $kurssi = str_replace(' ', '',  $kurssi);
    $kurssi = str_replace(',', '.', $kurssi);

    $kurssit[$koodi] = $kurssi;
    $maat[$koodi] = $maa;
  }

$aliakset = array('YEN' => 'JPY',
                  'EN' => 'JPY',
                  'JEN' => 'JPY',
                  'JENI' => 'JPY',
                  '$'   => 'USD',
                  'MK'  => 'FIM',
                  'E'   => 'EUR',
                  ''   => 'EUR',
                  ''   => 'JPY',
                  ''   => 'GBP'
                 );

$muut = array
(
  'ATS' => 13.7603,
  'BEF' => 40.3399,
  'DEM' => 1.95583,
  'ESP' => 166.386,
  'FIM' => 5.94573,
  'FRF' => 6.55957,
  'GRD' => 340.750,
  'IEP' => 0.787564,
  'ITL' => 1936.27,
  'LUF' => 40.3399,
  'NLG' => 2.20371,
  'PTE' => 200.482,
  'VAL' => 1936.27
);

$arvo = 1.0;
$from = 'USD';
$to   = 'EUR';

unset($argv[0]);
unset($argv[1]);
$cmdline = $argv[2];
$cmdline = ereg_replace('([0-9]) ([0-9])', '\1\2', $cmdline);
$cmdline = ereg_replace('([0-9])([^0-9,. ])', '\1 \2', $cmdline);
$cmdline = ereg_replace('([^0-9,. ]+)([0-9]+)', '\2 \1', $cmdline);
$args = explode(' ', $cmdline);

$arvo = $args[0];
if($args[1])$from = strtoupper($args[1]);
if($args[2])$to   = strtoupper($args[2]);

if(!$arvo || $arvo=='--help' || $arvo == '?' || $arvo == '/?')
{
  print "$src Kytt: .valukon <mr> [<valuutta> [<kohdevaluutta]]\n";
  return;
}

if(isset($maat[strtoupper($arvo)]))
{
  $arvo = strtoupper($arvo);
  echo "$dest $arvo: ", $maat[$arvo], "\n";
  return;
}

$arvo = str_replace(' ', '',  $arvo);
$arvo = str_replace(',', '.', $arvo);

if(isset($aliakset[$from])) $from = $aliakset[$from];
if(isset($aliakset[$to]))   $to = $aliakset[$to];

$virheet = array();
$realfrom = '';
if(isset($muut[$from]))
{
  $realfrom = $from;
  $from = 'EUR';
}
else
{
  if(!$kurssit[$from]) $virheet[] = 'Tuntematon valuutta "'.$from.'"';
}
$realto = '';
if(isset($muut[$to]))
{
  $realto = $to;
  $to = 'EUR';
}
else
{
  if(!$kurssit[$to])  $virheet[] = 'Tuntematon valuutta "'.$to.'"';
}

if($to=='EUR' && $from=='EUR' && !$realto && !$realfrom)
  $realto = 'FIM';

if(count($virheet))
{
  print "$src ";
  $c=0;foreach($virheet as $s){if($c++)print "; "; print $s;}
  print "\n";
  return;
}

print "$dest ";

if($realfrom)
{
  printf("(%.2f %s) ", round($arvo,2), $realfrom);
  $arvo = $arvo * $kurssit[$from] / $muut[$realfrom];
}
$tulos = $arvo * $kurssit[$to] / $kurssit[$from];
if($realto)
{
  printf("%.3f %s", round($arvo,3), $from);
  if($to != $from)printf(" = %.3f %s", round($tulos,3), $to);
  $to = $realto;
  $tulos = $tulos * $muut[$to];
  printf(" (%.2f %s)", round($tulos,2), $to);
}
else
{
  printf("%.3f %s", round($arvo,3), $from);
  if($to != $from)printf(" = %.3f %s", round($tulos,3), $to);
}
print "\n";
